/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *  
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *  
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; only version 2 of the License.      
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#include <l1394/l1394_session.h>
#include "nmm/services/registry/LocalRegistry.hpp"
#include "nmm/services/registry/Registry1394.hpp"
#include "nmm/services/registry/Factory1394.hpp"
#include "nmm/multimedia/Plugin.hpp"


#ifndef NMM_PLUGIN1394_HPP
#define NMM_PLUGIN1394_HPP

#include "nmm/nmm_prefix.hpp"
namespace NMM {
  class Registry;
  class NodeFactory;
  class Exception;


class Plugin1394 : public Plugin  {
public:
  Plugin1394() : Plugin("Plugin1394", 0), __registry1394(0), __factory1394(0) {}

  virtual ~Plugin1394();
  
  virtual void nmmInit()
    throw (const Exception&);

  virtual void nmmFini();

  virtual void nmmRegistryInit()
    throw (const Exception&);

  virtual void nmmRegistryFini();

  virtual void nmmFactoryInit()
    throw (const Exception&);

  virtual void nmmFactoryFini();

  virtual FactoryObject* getFactoryObject() { return 0; } // Dummy method


private:
  Registry1394* __registry1394;
  Factory1394*  __factory1394;
};

}


#include "nmm/nmm_suffix.hpp"

#endif
